## eigensoft 4.2

=== src/Makefile ===
CC = gcc
FC = gfortran 

# ----- 
CFLAGS = -I../include  -g 
FFLAGS = -I../include  -g
LDFLAGS = -I../include -pthread 

ND=nicksrc
ED=eigensrc
NLIB = $(ND)/libnick.a
MATHLIB = -lm

LAPACK = -llapack
ATLAS_LAPACK = -L/usr/lib64/atlas -llapack -lf77blas -lcblas -latlas

EXE = convertf mergeit smartpca smartrel pcatoy smarteigenstrat twstats eigenstrat

TWTAB = \"../src/smarttables/twtable\"

NLIBOBJS = $(ND)/gauss.o $(ND)/gds.o $(ND)/getpars.o $(ND)/linsubs.o $(ND)/sortit.o $(ND)/statsubs.o \
        $(ND)/strsubs.o $(ND)/vsubs.o $(ND)/xsearch.o


# ----- default 
%:%.o
	$(CC) $(LDFLAGS) $^ -o $@ $(MATHLIB)

%.o: %.c
	$(CC) -c $(CFLAGS) -o $@ $<

%.o: %.f
	$(FC) -c $(FFLAGS) -o $@ $<


.PHONY: all clean clobber install



# ----- define TW table in statsubs
$(ND)/statsubs.o: $(ND)/statsubs.c
	$(CC) -c $(CFLAGS) -DTWTAB=$(TWTAB) -o $@ $<

# ----- build nicksrc/libnick.a
$(NLIB):	$(NLIBOBJS)
	ar -r $(NLIB) $(NLIBOBJS)





# ----- build EIGENSOFT 
convertf:	convertf.o mcio.o egsubs.o admutils.o h2d.o $(ED)/exclude.o $(NLIB)
	$(CC) $(LDFLAGS) $^ -o $@ $(MATHLIB)

mergeit:	mergeit.o mcio.o admutils.o $(NLIB)
	$(CC) $(LDFLAGS) $^ -o $@ $(MATHLIB) 

pcatoy: 	eigensrc/pcatoy.o eigensrc/eigsubs.o eigensrc/eigx.o $(NLIB)
	$(FC) $(LDFLAGS) -o $@ $(LAPACK) $^ $(MATHLIB)

smartpca:	$(ED)/smartpca.o twsubs.o mcio.o qpsubs.o admutils.o egsubs.o regsubs.o \
		$(ED)/eigsubs.o $(ED)/eigx.o \
		$(ED)/workqueue.o $(ED)/exclude.o $(NLIB)
	$(FC) $(LDFLAGS) -o $@ $(LAPACK) $^ $(MATHLIB)

smartrel:	$(ED)/smartrel.o twsubs.o mcio.o qpsubs.o admutils.o egsubs.o regsubs.o \
		$(ED)/eigsubs.o $(ED)/eigx.o $(NLIB)    
	$(FC) $(LDFLAGS) -o $@ $(LAPACK) $^ $(MATHLIB)

smarteigenstrat:	$(ED)/smarteigenstrat.o mcio.o admutils.o $(NLIB)
	$(FC) $(LDFLAGS) -o $@ $(LAPACK) $^ $(MATHLIB)

twstats:	$(ED)/twstats.o $(NLIB) 
	$(CC) $(LDFLAGS) $^ -o $@  $(MATHLIB)

eigenstrat:	$(ED)/eigenstrat.o 
	$(CC) $(LDFLAGS) $^ -o $@  $(MATHLIB)




# ----- phony targets
all:    $(EXE)

install:  all
	mv $(EXE) ../bin

clobber:
	rm -f *.o core core.* $(ND)/*.o $(ED)/*.o
	rm -f $(EXE)
	cd ../bin/ ; rm -f $(EXE) ; cd ../src

clean:
	rm -f *.o core core.* *.o

=== debian/changelog ===
eigensoft (4.2-1) experimental; urgency=low

  * New upstream release.

 -- Steffen Moeller <moeller@debian.org>  Thu, 15 Sep 2011 14:20:03 +0200

eigensoft (3.0-1) UNRELEASED; urgency=low

  * Initial release (Closes: #641724).

 -- Steffen Moeller <moeller@debian.org>  Wed, 14 Sep 2011 10:35:55 +0200

=== debian/control ===
Source: eigensoft
Section: non-free/science
Priority: extra
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
DM-Upload-Allowed: yes
Uploaders: Steffen Moeller <moeller@debian.org>
Build-Depends: debhelper (>= 8.0.0),
 gfortran,
 libblas-dev,
 liblapack-dev
Standards-Version: 3.9.2
Homepage: http://www.hsph.harvard.edu/faculty/alkes-price/software/
Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/eigensoft/trunk
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/eigensoft/trunk/

Package: eigensoft
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, perl
Recommends: gnuplot
Description: reduction of population bias for genetic analyses
 The EIGENSOFT package combines functionality from the group's population
 genetics methods (Patterson et al. 2006) and their EIGENSTRAT stratification
 method (Price et al. 2006). The EIGENSTRAT method uses principal components
 analysis to explicitly model ancestry differences between cases and
 controls along continuous axes of variation; the resulting correction is
 specific to a candidate marker's variation in frequency across ancestral
 populations, minimizing spurious associations while maximizing power to
 detect true associations. The EIGENSOFT package has a built-in plotting
 script and supports multiple file formats and quantitative phenotypes.

Package: eigensoft-dbg
Architecture: any
Section: non-free/debug
Depends: ${misc:Depends}, eigensoft (= ${binary:Version})
Description: debug symbols for the eigensoft package
 The EIGENSOFT package helps with distinguishing inherited differences in
 populations from those that are discriminating patients from non-affected
 individuals. This debug package adds symbols that help with the location
 of the problem when an unexpected crash of the program occurs.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ 

override_dh_auto_build:
	$(MAKE) DEBUG_OPTIONS=-g -C src all
	cd src && make install

override_dh_clean:
	dh_clean
	$(MAKE) -C src clobber

override_dh_strip:
	dh_strip --dbg-package=eigensoft-dbg

override_dh_install:
	dh_install
	# the file is empty
	rm -f debian/eigensoft/usr/share/eigen*/POPGEN/HGDP.X.perl

VERSION=4.2
get-orig-source:
	[ -r ../eig$(VERSION).tar.gz ] || wget http://www.hsph.harvard.edu/faculty/alkes-price/files/eig$(VERSION).tar.gz -O ../eig$(VERSION).tar.gz
	rm -rf ../EIG$(VERSION)
	cd .. && tar xzf eig$(VERSION).tar.gz
	cd .. && mv EIG$(VERSION) eigensoft-$(VERSION)
	find ../eigensoft-$(VERSION)/bin -type f | grep -v '.perl$$' | egrep -v '(fixgreen|ploteig)' | xargs -r rm
	find ../eigensoft-$(VERSION)/POPGEN -type f | grep -v '.perl$$' | xargs -r chmod -x
	find ../eigensoft-$(VERSION)/CONVERTF -type f | grep -v '.perl$$' | xargs -r chmod -x
	find ../eigensoft-$(VERSION)/EIGENSTRAT -type f | grep -v '.perl$$' | xargs -r chmod -x
	#find ../eigensoft-$(VERSION) -name "*.o" -delete
	make -C ../eigensoft-$(VERSION)/src clobber
	cd .. && tar cjf eigensoft_$(VERSION).orig.tar.bz2 eigensoft-$(VERSION)

=== debian/watch ===
# Example watch control file for uscan
# Rename this file to "watch" and then you can run the "uscan" command
# to check for upstream updates and more.
# See uscan(1) for format

# Compulsory line, this is a version 3 file
version=3
http://www.hsph.harvard.edu/faculty/alkes-price/files/eig([0-9.]+).tar.gz

## eigensoft 6.0.1%2Bds

=== debian/changelog ===
eigensoft (6.0.1+ds-1) unstable; urgency=medium

  [ Andreas Tille ]
  * New upstream version
  * Fixed d/watch
  * Use Files-Excluded to strip upstream source
  * Cleanup d/rules
  * Moved packaging from SVN to Git
  * cme fix dpkg-control
  * Priority: optional
  * debhelper 9
  * Remove -dbg package which is autogenerated now
  * DEP3 header and removed unused patches
  * Removed README.Debian which is not user oriented
  * Add missing Build-Depends libgsl-dev
  * Propagate hardening options
  * Fix permission of some Perl scripts
  * Remove dubious non-perl script consisting from comment only

  [ Petter Reinholdtsen ]
  * Added lapacke.patch to link with -llapacke and -llapack.
  * Added liblapacke-dev as build-dependency.
  * Added a simple autopkgtest script to verify that at least some of the
    binaries are able to run.

 -- Andreas Tille <tille@debian.org>  Sun, 07 Feb 2016 21:30:13 +0100

## eigensoft 6.0.1+ds

=== src/Makefile ===
# ----- If the user defined OPENBLAS on the command line or use that
ifdef OPENBLAS
$(info $$OPENBLAS is [${OPENBLAS}])
else
# ----- If this is Broad, check the path to see if "use .openblas-0.2.8"
ifeq ($(DOMAINNAME),broadinstitute.org)
$(info *** Broad Institute users can execute use .openblas-0.2.8 and use GCC-4.9 to link to OpenBLAS ***)
else
# ----- On orchestra this will work  
OPENBLAS=/opt/openblas
$(info setting $$OPENBLAS to [${OPENBLAS}])
endif
endif

ifdef OPENBLAS
CFLAGS  = -I../include -I$(OPENBLAS)/include -D_GNU_SOURCE
LDFLAGS = -L$(OPENBLAS)/lib -D_GNU_SOURCE
LDLIBS  = -Wl,-Bdynamic -lgsl -Wl,-Bstatic -lopenblas -Wl,-Bdynamic -lgfortran -pthread -lm
else
CFLAGS  = -I../include -D_GNU_SOURCE
LDFLAGS = -D_GNU_SOURCE
LDLIBS  = -lgsl -lopenblas -lgfortran -pthread -lm
endif

CC = gcc
LD = ld


ifeq ($(OPTIMIZE), 1)
	CFLAGS += -O2
endif

ifeq ($(DEBUG), 1)
	CFLAGS += -g # enable debugging
endif

ifeq ($(PROFILING), 1)
	CFLAGS += -pg # enable profiling
endif

ND=nicksrc
ED=eigensrc
KG=ksrc
NLIB = $(ND)/libnick.a

# ----- phony targets
.PHONY: all clean clobber install

EXE = baseprog convertf mergeit pca \
	$(ED)/pcatoy $(ED)/smartrel $(ED)/smarteigenstrat \
	$(ED)/twstats $(ED)/eigenstrat $(ED)/eigenstratQTL $(ED)/smartpca

all:    $(EXE)

install:  all
	mv $(EXE) ../bin

clobber:
	rm -f *.o */*.o */*.a
	rm -f $(EXE)
	cd ../bin/ ; rm -f $(notdir, $(EXE)) ; cd ../src

clean:
	rm -f *.o core core.* *.o  

# ----- build nicksrc/libnick.a
$(NLIB):
	$(MAKE) -C $(ND)

baseprog:	baseprog.o mcio.o egsubs.o admutils.o h2d.o $(ED)/exclude.o $(NLIB)

convertf:	convertf.o mcio.o egsubs.o admutils.o h2d.o $(ED)/exclude.o $(NLIB)

mergeit:	mergeit.o mcio.o admutils.o $(NLIB)

pca:	pca.o $(ED)/eigsubs.o eigx.o $(NLIB)

$(ED)/pcatoy: 	$(ED)/pcatoy.o eigensrc/eigsubs.o eigensrc/eigx.o $(NLIB)

$(ED)/smartrel:	$(ED)/smartrel.o twsubs.o mcio.o qpsubs.o admutils.o egsubs.o regsubs.o \
		$(ED)/eigsubs.o $(ED)/eigx.o $(ED)/smartsubs.o $(NLIB)    

$(ED)/smarteigenstrat:	$(ED)/smarteigenstrat.o mcio.o admutils.o $(NLIB)

$(ED)/twstats:	$(ED)/twstats.o $(NLIB) 

#$(ED)/eigenstrat:	$(ED)/eigenstrat.o 

#$(ED)/eigenstratQTL:	$(ED)/eigenstratQTL.o 

$(ED)/smartpca:	$(ED)/smartpca.o $(ED)/eigsubs.o $(ED)/exclude.o $(ED)/smartsubs.o $(ED)/eigx.o \
		twsubs.o mcio.o qpsubs.o admutils.o egsubs.o regsubs.o gval.o \
		$(NLIB) \
          	$(KG)/kjg_fpca.o $(KG)/kjg_gsl.o

smartpca: $(ED)/smartpca
	cp $< $@

$(ED)/fffpca:	$(ED)/fffpca.o $(ED)/eigsubs.o $(ED)/exclude.o $(ED)/smartsubs.o $(ED)/eigx.o \
		twsubs.o mcio.o qpsubs.o admutils.o egsubs.o regsubs.o gval.o \
		$(NLIB) \
          	$(KG)/kjg_fpca.o $(KG)/kjg_gsl.o

fffpca: $(ED)/fffpca
	cp $< $@

=== src/ksrc/Makefile ===
CFLAGS = -I../../include -I/opt/openblas/include

ifeq ($(DEBUG), 1)
	CFLAGS += -g # enable debugging
endif

ifeq ($(PROFILING), 1)
	CFLAGS += -pg # enable profiling
endif

.PHONY: all clean

all: kjg_gsl.o kjg_fpca.o

clean:
	rm *.o

=== src/nicksrc/Makefile ===
CFLAGS = -I../../include -D_GNU_SOURCE

ifeq ($(DEBUG), 1)
	CFLAGS += -g # enable debugging
endif

ifeq ($(PROFILING), 1)
	CFLAGS += -pg # enable profiling
endif

TWTAB = '"../smarttables/twtable"'

NLIB = libnick.a
NLIBOBJS = gauss.o gds.o getpars.o linsubs.o sortit.o statsubs.o strsubs.o vsubs.o xsearch.o

.PHONY: all clean

all: $(NLIB)

clean:
	rm *.a *.o

# ----- build nicksrc/libnick.a
$(NLIB): $(NLIBOBJS)
	ar -r $@ $^

statsubs.o: CFLAGS += -DTWTAB=$(TWTAB)

=== debian/control ===
Source: eigensoft
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Steffen Moeller <moeller@debian.org>,
           Andreas Tille <tille@debian.org>
Section: non-free/science
XS-Autobuild: no
Priority: optional
Build-Depends: debhelper (>= 9),
               gfortran,
               libblas-dev,
               liblapack-dev,
               liblapacke-dev,
               libgsl-dev
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/eigensoft.git
Vcs-Git: https://anonscm.debian.org/debian-med/eigensoft.git
Homepage: http://www.hsph.harvard.edu/faculty/alkes-price/software/

Package: eigensoft
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${perl:Depends}
Recommends: gnuplot
Description: reduction of population bias for genetic analyses
 The EIGENSOFT package combines functionality from the group's population
 genetics methods (Patterson et al. 2006) and their EIGENSTRAT stratification
 method (Price et al. 2006). The EIGENSTRAT method uses principal components
 analysis to explicitly model ancestry differences between cases and
 controls along continuous axes of variation; the resulting correction is
 specific to a candidate marker's variation in frequency across ancestral
 populations, minimizing spurious associations while maximizing power to
 detect true associations. The EIGENSOFT package has a built-in plotting
 script and supports multiple file formats and quantitative phenotypes.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ 

override_dh_auto_build:
	$(MAKE) DEBUG_OPTIONS=-g -C src all
	cd src && make install

override_dh_clean:
	dh_clean
	$(MAKE) -C src clobber

override_dh_install:
	dh_install
	find debian/eigensoft/usr/share/ -type f -empty -delete
	# file consists only from single line with wrong interpreter
	find debian/eigensoft/usr/share/ -type f -name HGDP.X.perl -delete

override_dh_fixperms:
	dh_fixperms
	find debian/*/usr/share/eigensoft -type f -name "*.perl" -exec chmod +x \{\} \;

get-orig-source:
	uscan --verbose --force-download --repack --compression xz

=== debian/watch ===
version=3
opts="repacksuffix=+ds,dversionmangle=s/\+ds//g" \
  https://data.broadinstitute.org/alkesgroup/EIGENSOFT/EIG([0-9.]+)\.tar\.gz

## eigensoft 6.1.3+dfsg

=== src/Makefile ===
CFLAGS += -I../include
LDLIBS += -lgsl -lopenblas -lgfortran -lrt

ifeq ($(OPTIMIZE), 1)
	CFLAGS += -O2
endif

ifeq ($(DEBUG), 1)
	CFLAGS += -g # enable debugging
endif

ifeq ($(PROFILING), 1)
	CFLAGS += -pg # enable profiling
endif

ND=nicksrc
ED=eigensrc
KD=ksrc

NLIB = $(ND)/libnick.a

# ----- phony targets
.PHONY: all clean clobber install

EXE = baseprog convertf mergeit pca \
	$(ED)/pcatoy $(ED)/smartrel $(ED)/smarteigenstrat \
	$(ED)/twstats $(ED)/eigenstrat $(ED)/eigenstratQTL $(ED)/smartpca

all:    $(EXE)

install:  all
	mv $(EXE) ../bin

clobber:
	rm -f *.o */*.o */*.a
	rm -f $(EXE)
	cd ../bin/ ; rm -f $(notdir $(EXE)) ; cd ../src

clean:
	rm -f *.o core core.* *.o  

# ----- build nicksrc/libnick.a
$(NLIB):
	$(MAKE) -C $(ND)

baseprog:	baseprog.o mcio.o egsubs.o admutils.o h2d.o $(ED)/exclude.o $(NLIB)

convertf:	convertf.o mcio.o egsubs.o admutils.o h2d.o $(ED)/exclude.o $(NLIB)

mergeit:	mergeit.o mcio.o admutils.o $(NLIB)

pca:	pca.o $(ED)/eigsubs.o eigx.o $(NLIB)

pcaselection:	pcaselection.o mcio.o admutils.o $(NLIB)

$(ED)/pcatoy: 	$(ED)/pcatoy.o eigensrc/eigsubs.o eigensrc/eigx.o $(NLIB)

$(ED)/smartrel:	$(ED)/smartrel.o twsubs.o mcio.o qpsubs.o admutils.o egsubs.o regsubs.o \
		$(ED)/eigsubs.o $(ED)/eigx.o $(ED)/smartsubs.o $(NLIB)    

$(ED)/smarteigenstrat:	$(ED)/smarteigenstrat.o mcio.o admutils.o $(NLIB)

$(ED)/twstats:	$(ED)/twstats.o $(NLIB) 

$(ED)/eigenstrat:	$(ED)/eigenstrat.o 

$(ED)/eigenstratQTL:	$(ED)/eigenstratQTL.o 

$(ED)/smartpca:	$(ED)/smartpca.o $(ED)/eigsubs.o $(ED)/exclude.o $(ED)/smartsubs.o $(ED)/eigx.o \
		twsubs.o mcio.o qpsubs.o admutils.o egsubs.o regsubs.o gval.o \
		$(NLIB) \
          	$(KD)/kjg_fpca.o $(KD)/kjg_gsl.o

smshrink:		smshrink.o $(ED)/eigsubs.o $(ED)/exclude.o $(ED)/smartsubs.o $(ED)/eigx.o \
		twsubs.o mcio.o qpsubs.o admutils.o egsubs.o regsubs.o gval.o \
		$(NLIB) \
          	$(KD)/kjg_fpca.o $(KD)/kjg_gsl.o

smartpca: $(ED)/smartpca
	cp $< $@

$(ED)/fffpca:	$(ED)/fffpca.o $(ED)/eigsubs.o $(ED)/exclude.o $(ED)/smartsubs.o $(ED)/eigx.o \
		twsubs.o mcio.o qpsubs.o admutils.o egsubs.o regsubs.o gval.o \
		$(NLIB) \
          	$(KD)/kjg_fpca.o $(KD)/kjg_gsl.o

fffpca: $(ED)/fffpca
	cp $< $@

=== debian/changelog ===
eigensoft (6.1.3+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Upstream has changed extensions from .pl to .perl

 -- Andreas Tille <tille@debian.org>  Fri, 05 Aug 2016 23:40:38 +0200

eigensoft (6.1.2+dfsg-1) unstable; urgency=medium

  [ Andreas Tille ]
  * New upstream version
  * Adapt watch file to match new version string
  * relicense Debian packaging as BSD-3-clause
  * cme fix dpkg-control
  * hardening=+bindnow
  * Leave only wrapper scripts in /usr/bin, executables go to /usr/lib/eigensoft
  * add at least one manpage
  * add examples

  [ Tatiana Malygina ]
  * Fix headers

 -- Andreas Tille <tille@debian.org>  Tue, 19 Jul 2016 11:23:59 +0200

## eigensoft 6.1.4%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,7 @@
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Steffen Moeller <moeller@debian.org>,
            Andreas Tille <tille@debian.org>
-Section: non-free/science
-XS-Autobuild: no
+Section: science
 Priority: optional
 Build-Depends: debhelper (>= 9),
                gfortran,
@@ -11,9 +10,9 @@
                liblapack-dev,
                liblapacke-dev,
                libgsl-dev
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/eigensoft.git
-Vcs-Git: https://anonscm.debian.org/debian-med/eigensoft.git
+Vcs-Git: https://anonscm.debian.org/git/debian-med/eigensoft.git
 Homepage: http://www.hsph.harvard.edu/faculty/alkes-price/software/
 
 Package: eigensoft

## eigensoft 6.1.4+dfsg

=== src/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 CFLAGS += -I../include
-LDLIBS += -lgsl -lopenblas -lgfortran -lrt
+LDLIBS += -lgfortran -lrt -Wl,-Bstatic -lgsl -lopenblas -Wl,-Bdynamic -fopenmp
 
 ifeq ($(OPTIMIZE), 1)
 	CFLAGS += -O2
@@ -22,7 +22,7 @@
 # ----- phony targets
 .PHONY: all clean clobber install
 
-EXE = baseprog convertf mergeit pca \
+EXE = baseprog convertf mergeit pca pcaselection \
 	$(ED)/pcatoy $(ED)/smartrel $(ED)/smarteigenstrat \
 	$(ED)/twstats $(ED)/eigenstrat $(ED)/eigenstratQTL $(ED)/smartpca

=== debian/changelog ===
eigensoft (6.1.4+dfsg-1build1) artful; urgency=medium

  * No-change rebuild for libgsl soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 06 Aug 2017 00:09:51 +0000

eigensoft (6.1.4+dfsg-1) unstable; urgency=medium

  * New upstream version
  * fix perl interpreter path

 -- Andreas Tille <tille@debian.org>  Sun, 16 Oct 2016 15:16:45 +0200

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,15 @@
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
+
+export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
+
+DEBPKGNAME     := $(shell dpkg-parsechangelog | awk '/^Source:/ {print $$2}')
+
+WRAPPERS=evec2pca-ped \
+         evec2pca \
+         smarteigenstrat \
+         smartpca
 
 %:
 	dh $@ 
@@ -19,10 +28,22 @@
 	find debian/eigensoft/usr/share/ -type f -empty -delete
 	# file consists only from single line with wrong interpreter
 	find debian/eigensoft/usr/share/ -type f -name HGDP.X.perl -delete
+	# Fix wrappers and drop *.perl extension in /usr/bin while keeping
+	# the original name in /usr/lib/debian-med/bin
+	mkdir -p debian/$(DEBPKGNAME)/usr/lib/debian-med/bin
+	for pl in $(WRAPPERS) ; do \
+	    rm debian/$(DEBPKGNAME)/usr/bin/$${pl} ; \
+	    sed -i \
+	        -e "s?\(command[[:space:]]*=[[:space:]]*\"\)\($${pl}\)?\1/usr/lib/$(DEBPKGNAME)/\2?" \
+                -e "s?\(cmd[[:space:]]*=[[:space:]]*\"\)\($${pl}\)?\1/usr/lib/$(DEBPKGNAME)/\2?" \
+                -e "s?\(cmd[[:space:]]*=[[:space:]]*\"\)\(evec2pca.*\)\.perl?\1?" \
+                -e "s?\($${pl}\)\.perl?\1?" \
+	        debian/$(DEBPKGNAME)/usr/bin/$${pl}.perl ; \
+	    cp -a debian/$(DEBPKGNAME)/usr/bin/$${pl}.perl debian/$(DEBPKGNAME)/usr/bin/$${pl} ; \
+	    mv debian/$(DEBPKGNAME)/usr/bin/$${pl}.perl debian/$(DEBPKGNAME)/usr/lib/debian-med/bin ; \
+	done
+	rm debian/$(DEBPKGNAME)/usr/bin/gc.perl
 
 override_dh_fixperms:
 	dh_fixperms
 	find debian/*/usr/share/eigensoft -type f -name "*.perl" -exec chmod +x \{\} \;
-
-get-orig-source:
-	uscan --verbose --force-download --repack --compression xz

=== debian/watch ===
version=3
opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz" \
  https://data.broadinstitute.org/alkesgroup/EIGENSOFT/EIG-*([0-9.]+)\.tar\.gz

## eigensoft 7.2.1+dfsg

=== src/Makefile ===
override CFLAGS += -I../include -I/usr/include/openblas
#LDLIBS += -lgsl -lopenblas -lrt -lm
override LDLIBS += -lgsl -lopenblas -lm -lpthread
# Some Linux distributions require separate lapacke library
# override LDLIBS += -llapacke
# Mac additions using homebrew installations
#override CFLAGS += -I/usr/local/opt/openblas/include -I/usr/local/opt/gsl/include
#override LDFLAGS += -L/usr/local/opt/openblas/lib -L/usr/local/opt/gsl/lib
# Harvard Medical School O2 cluster additions
#override CFLAGS += -I/n/app/openblas/0.2.19/include -I/n/app/gsl/2.3/include
#override LDFLAGS += -L/n/app/openblas/0.2.19/lib -L/n/app/gsl/2.3/lib/

ifeq ($(OPTIMIZE), 1)
	CFLAGS += -O2
endif

ifeq ($(DEBUG), 1)
	CFLAGS += -g # enable debugging
endif

ifeq ($(PROFILING), 1)
	CFLAGS += -pg # enable profiling
endif

ND=nicksrc
ED=eigensrc
KD=ksrc

NLIB = $(ND)/libnick.a

# ----- phony targets
.PHONY: all clean clobber install

EXE = baseprog convertf mergeit pca smshrink \
	$(ED)/pcatoy $(ED)/smartrel $(ED)/smarteigenstrat \
	$(ED)/twstats $(ED)/eigenstrat $(ED)/eigenstratQTL $(ED)/smartpca

all:    $(EXE)

install:  all
	mv $(EXE) ../bin

clobber:
	rm -f *.o */*.o */*.a $(ND)/*.o $(ED)/*.o $(KD)/*.o
	rm -f $(EXE)
	cd ../bin/ ; rm -f $(notdir $(EXE)) ; cd ../src

clean:
	rm -f *.o core core.* *.o $(ND)/*.o $(ED)/*.o $(KD)/*.o $(EXE)

# ----- build nicksrc/libnick.a
$(NLIB):
	$(MAKE) -C $(ND)

baseprog:	baseprog.o mcio.o egsubs.o admutils.o h2d.o $(ED)/exclude.o $(NLIB)

convertf:	convertf.o mcio.o egsubs.o admutils.o h2d.o $(ED)/exclude.o $(NLIB)

mergeit:	mergeit.o mcio.o admutils.o $(NLIB)

pca:	pca.o $(ED)/eigsubs.o eigensrc/eigx.o $(NLIB)

$(ED)/pcatoy: 	$(ED)/pcatoy.o eigensrc/eigsubs.o eigensrc/eigx.o $(NLIB)

$(ED)/smartrel:	$(ED)/smartrel.o twsubs.o mcio.o qpsubs.o admutils.o egsubs.o regsubs.o \
		$(ED)/eigsubs.o $(ED)/eigx.o $(ED)/smartsubs.o $(NLIB)    

$(ED)/smarteigenstrat:	$(ED)/smarteigenstrat.o mcio.o admutils.o $(NLIB)

$(ED)/twstats:	$(ED)/twstats.o $(NLIB) 

$(ED)/smartpca:	$(ED)/smartpca.o $(ED)/eigsubs.o $(ED)/exclude.o $(ED)/smartsubs.o $(ED)/eigx.o \
		mcio.o qpsubs.o admutils.o egsubs.o regsubs.o gval.o \
		$(NLIB) \
          	$(KD)/kjg_fpca.o $(KD)/kjg_gsl.o 
          	#-lpthread

smshrink:		smshrink.o $(ED)/eigsubs.o $(ED)/exclude.o $(ED)/smartsubs.o $(ED)/eigx.o \
		twsubs.o mcio.o qpsubs.o admutils.o egsubs.o regsubs.o gval.o \
		$(NLIB) \
          	$(KD)/kjg_fpca.o $(KD)/kjg_gsl.o

=== src/nicksrc/Makefile ===
CFLAGS = -I../../include -D_GNU_SOURCE

ifeq ($(DEBUG), 1)
	CFLAGS += -g # enable debugging
endif

ifeq ($(PROFILING), 1)
	CFLAGS += -pg # enable profiling
endif

NLIB = libnick.a
NLIBOBJS = gauss.o gds.o getpars.o linsubs.o sortit.o statsubs.o strsubs.o vsubs.o xsearch.o twtable.o

.PHONY: all clean

all: $(NLIB)

clean:
	rm *.a *.o

# ----- build nicksrc/libnick.a
$(NLIB): $(NLIBOBJS)
	ar -r $@ $^

=== debian/changelog ===
eigensoft (7.2.1+dfsg-3build1) jammy; urgency=medium

  * No-change rebuild against libgsl27

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 07 Dec 2021 17:29:17 +0000

eigensoft (7.2.1+dfsg-3) unstable; urgency=medium

  * Fix watchfile to detect new versions on github (routine-update)
  * Standards-Version: 4.6.0 (routine-update)
  * Hardening=+all

 -- Andreas Tille <tille@debian.org>  Mon, 27 Sep 2021 20:55:08 +0200

eigensoft (7.2.1+dfsg-2) unstable; urgency=medium

  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Remove trailing whitespace in debian/rules (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Andreas Tille <tille@debian.org>  Thu, 23 Jul 2020 08:53:03 +0200

eigensoft (7.2.1+dfsg-1) unstable; urgency=medium

  [ Steffen Moeller ]
  * debian/upstream/metadata; Added references to registries and paper

  [ Andreas Tille ]
  * New upstream version
  * d/watch: Source is now on Github
  * d/rules: Do not parse d/changelog
  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.1.5

 -- Andreas Tille <tille@debian.org>  Mon, 16 Jul 2018 16:10:33 +0200

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,21 @@
 Source: eigensoft
-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Steffen Moeller <moeller@debian.org>,
            Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper-compat (= 13),
                gfortran,
                libblas-dev,
                liblapack-dev,
                liblapacke-dev,
                libgsl-dev
-Standards-Version: 3.9.8
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/eigensoft.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/eigensoft.git
+Standards-Version: 4.6.0
+Vcs-Browser: https://salsa.debian.org/med-team/eigensoft
+Vcs-Git: https://salsa.debian.org/med-team/eigensoft.git
 Homepage: http://www.hsph.harvard.edu/faculty/alkes-price/software/
+Rules-Requires-Root: no
 
 Package: eigensoft
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/default.mk

WRAPPERS=evec2pca-ped \
         evec2pca \
         smarteigenstrat \
         smartpca

%:
	dh $@

override_dh_auto_build:
	$(MAKE) DEBUG_OPTIONS=-g -C src all
	cd src && make install

override_dh_clean:
	dh_clean
	$(MAKE) -C src clobber

override_dh_install:
	dh_install
	find debian/eigensoft/usr/share/ -type f -empty -delete
	# file consists only from single line with wrong interpreter
	find debian/eigensoft/usr/share/ -type f -name HGDP.X.perl -delete
	# Fix wrappers and drop *.perl extension in /usr/bin while keeping
	# the original name in /usr/lib/debian-med/bin
	mkdir -p debian/$(DEB_SOURCE)/usr/lib/debian-med/bin
	for pl in $(WRAPPERS) ; do \
	    rm debian/$(DEB_SOURCE)/usr/bin/$${pl} ; \
	    sed -i \
	        -e "s?\(command[[:space:]]*=[[:space:]]*\"\)\($${pl}\)?\1/usr/lib/$(DEB_SOURCE)/\2?" \
                -e "s?\(cmd[[:space:]]*=[[:space:]]*\"\)\($${pl}\)?\1/usr/lib/$(DEB_SOURCE)/\2?" \
                -e "s?\(cmd[[:space:]]*=[[:space:]]*\"\)\(evec2pca.*\)\.perl?\1?" \
                -e "s?\($${pl}\)\.perl?\1?" \
	        debian/$(DEB_SOURCE)/usr/bin/$${pl}.perl ; \
	    cp -a debian/$(DEB_SOURCE)/usr/bin/$${pl}.perl debian/$(DEB_SOURCE)/usr/bin/$${pl} ; \
	    mv debian/$(DEB_SOURCE)/usr/bin/$${pl}.perl debian/$(DEB_SOURCE)/usr/lib/debian-med/bin ; \
	done
	rm debian/$(DEB_SOURCE)/usr/bin/gc.perl

override_dh_fixperms:
	dh_fixperms
	find debian/*/usr/share/eigensoft -type f -name "*.perl" -exec chmod +x \{\} \;

=== debian/tests/control ===
Depends: @
Tests: test-working

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz" \
  https://github.com/DReichLab/EIG/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## eigensoft 8.0.0%2Bdfsg

=== debian/changelog ===
eigensoft (8.0.0+dfsg-2build1) oracular; urgency=medium

  * Rebuild against new libgsl28.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 30 Jul 2024 08:36:23 +0200

eigensoft (8.0.0+dfsg-2) unstable; urgency=medium

  * Fix download filename in watch file
  * Standards-Version: 4.6.2 (routine-update)
  * Change interpreter PATH only in debian dir not in upstream source
    Closes: #1045139

 -- Andreas Tille <tille@debian.org>  Wed, 31 Jan 2024 19:16:19 +0100

eigensoft (8.0.0+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.1 (routine-update)
  * Fix Perl interpreter path

 -- Andreas Tille <tille@debian.org>  Fri, 28 Oct 2022 10:03:37 +0200

## eigensoft 8.0.0+dfsg

=== src/Makefile ===
--- 
+++ 
@@ -7,8 +7,10 @@
 #override CFLAGS += -I/usr/local/opt/openblas/include -I/usr/local/opt/gsl/include
 #override LDFLAGS += -L/usr/local/opt/openblas/lib -L/usr/local/opt/gsl/lib
 # Harvard Medical School O2 cluster additions
-#override CFLAGS += -I/n/app/openblas/0.2.19/include -I/n/app/gsl/2.3/include
-#override LDFLAGS += -L/n/app/openblas/0.2.19/lib -L/n/app/gsl/2.3/lib/
+ifdef SLURM_CONF
+override CFLAGS += -I/n/app/openblas/0.2.19/include -I/n/app/gsl/2.3/include
+override LDFLAGS += -L/n/app/openblas/0.2.19/lib -L/n/app/gsl/2.3/lib/
+endif
 
 ifeq ($(OPTIMIZE), 1)
 	CFLAGS += -O2
@@ -31,7 +33,7 @@
 # ----- phony targets
 .PHONY: all clean clobber install
 
-EXE = baseprog convertf mergeit pca smshrink \
+EXE = baseprog convertf mergeit pca \
 	$(ED)/pcatoy $(ED)/smartrel $(ED)/smarteigenstrat \
 	$(ED)/twstats $(ED)/eigenstrat $(ED)/eigenstratQTL $(ED)/smartpca
 
@@ -74,9 +76,3 @@
 		$(NLIB) \
           	$(KD)/kjg_fpca.o $(KD)/kjg_gsl.o 
           	#-lpthread
-
-smshrink:		smshrink.o $(ED)/eigsubs.o $(ED)/exclude.o $(ED)/smartsubs.o $(ED)/eigx.o \
-		twsubs.o mcio.o qpsubs.o admutils.o egsubs.o regsubs.o gval.o \
-		$(NLIB) \
-          	$(KD)/kjg_fpca.o $(KD)/kjg_gsl.o
-

=== src/ksrc/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-CFLAGS = -I../../include -I/opt/openblas/include
+CFLAGS += -I../../include -I/opt/openblas/include
 
 ifeq ($(DEBUG), 1)
 	CFLAGS += -g # enable debugging

=== src/nicksrc/Makefile ===
override CFLAGS += -c -O3   -g -p -Wimplicit -I../../include

all: libnick.a

libnick.a: strsubs.o sortit.o vsubs.o statsubs.o linsubs.o getpars.o xsearch.o gauss.o gds.o
	ar -r libnick.a $^
	ranlib libnick.a

clean:
	rm -f *.o
	rm -f libnick.a

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: eigensoft
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Steffen Moeller <moeller@debian.org>,
            Andreas Tille <tille@debian.org>
 Section: science
@@ -11,7 +10,7 @@
                liblapack-dev,
                liblapacke-dev,
                libgsl-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/med-team/eigensoft
 Vcs-Git: https://salsa.debian.org/med-team/eigensoft.git
 Homepage: http://www.hsph.harvard.edu/faculty/alkes-price/software/

=== debian/rules ===
--- 
+++ 
@@ -42,6 +42,9 @@
 	    cp -a debian/$(DEB_SOURCE)/usr/bin/$${pl}.perl debian/$(DEB_SOURCE)/usr/bin/$${pl} ; \
 	    mv debian/$(DEB_SOURCE)/usr/bin/$${pl}.perl debian/$(DEB_SOURCE)/usr/lib/debian-med/bin ; \
 	done
+	for pl in `grep -lR '/usr/.*/bin/perl' | grep -v debian/rules` ; do \
+	    sed -i -e "s?/usr/.*/bin/perl?/usr/bin/perl?" $${pl} ; \
+	done
 	rm debian/$(DEB_SOURCE)/usr/bin/gc.perl
 
 override_dh_fixperms:
